Subject: bug#77973: 30.1; `which-key' breaks `string-rectangle' after popup shown

From: Eli Zaretskii <[email-masked]>
Date: Wed, 23 Apr 2025 14:51:34 +0300

> From: Alcor <[email-masked]>
> Cc: [email-masked]
> Date: Tue, 22 Apr 2025 21:46:57 +0200
> 
> As done in many other places in rect.el fixes the issue on 30.x -
> however, I've also tried backporting
> 3a8222e700304e4dff84fcdfa8ff2a4e48646c82 onto 30.1 and it worked without
> any issues, on top of it being faster as well.
> 
> Would it be possible to cherry-pick 3a8222e onto the emacs-30 branch so
> a fix is available on 30.2? IMO, this bug is annoyingly easy to trigger
> on 30.1 when using `which-key-mode' (see video in previous message), and
> it's not trivial to unbreak rectangle-mark-mode after running into it,
> so having it in the next bugfix release would improve things
> significantly.

My bother with commit 3a8222e is that it uses move-to-column, which
might behave in surprising ways when there are 'display' properties,
TABs, composed characters, and other display features around.

Did someone try the new code in those cases?  If not, I'd like you or
someone else to try that first, because I'd like to avoid introducing
regressions into Emacs 30.2.